import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "$hOVQPOOQhQPOOOOQO'#C_'#C_OsQPO'#CcOOQO'#Cf'#CfOVQPO'#ChO![QPO'#CjOOQO'#Cc'#CcOOQO'#C^'#C^OVQPO,58zOVQPO,58{OVQPO,58|O!aQPO,59QO!fQPO'#CiO!wQPO,59SOVQPO,59UOOQO1G.f1G.fO!|QPO1G.gO#bQPO1G.hOOQO1G.l1G.lOVQPO'#ClO#vQPO,59TOOQO1G.n1G.nO$OQPO1G.pO$TQPO,59WOOQO-E6j-E6jOOQO7+$[7+$[",
  stateData: "$f~OcOS~OWVOXROZSO_UOhTO~OdXOeYOfZO~Og[OaVXdVXeVXfVXiVXjVX~Oh_O~OXcO~OdXOeYOfZOidOj]X~OjfO~OdXOaTieTifTiiTijTi~OdXOeYOaUifUiiUijUi~OidOj]a~OjjO~OdXOeYOfZOi`aj`a~O",
  goto: "!naPPbu!O!O!OuPP!XP!X!b!XP!hQPOS]T_Q`XQaYQbZRhd_WOTXYZ_d_QOTXYZ_d_VOTXYZ_dQ^TRg_Qe]Rie",
  nodeNames: "⚠ Program Expression BinaryExpression Boolean Product Addition Scalar Number String MeasureReference MachineMeasureReference Parentheses Arguments FunctionCall Identifier",
  maxTerm: 26,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "*P~RkX^!vpq!vqr#krs#vxy$tyz$yz{%O{|%T|}%Y}!O%T!O!P%_!P!Q%O!Q![%d!^!_%}!_!`#k!`!a%}!c!}&V#T#o&V#o#p&b#y#z!v$f$g!v#BY#BZ!v$IS$I_!v$I|$JO!v$JT$JU!v$KV$KW!v&FU&FV!v~!{Yc~X^!vpq!v#y#z!v$f$g!v#BY#BZ!v$IS$I_!v$I|$JO!v$JT$JU!v$KV$KW!v&FU&FV!v~#nP!_!`#q~#vOd~~#yTpq$Y!Q![$Y!c!}$Y#R#S$Y#T#o$Y~$]Upq$Yrs$o!Q![$Y!c!}$Y#R#S$Y#T#o$Y~$tOX~~$yOh~~%OOj~~%TOe~~%YOf~~%_Oi~~%dOg~~%iQW~!O!P%o!Q![%d~%rP!Q![%u~%zPW~!Q![%u~&SPd~!_!`#q~&[Q_~!c!}&V#T#o&V~&eP#o#p&h~&kP!o!p&n~&qP#X#Y&t~&wP#T#U&z~&}P#g#h'Q~'TP#i#j'W~'ZP#f#g'^~'aP#X#Y'd~'gP#p#q'j~'mPrs'p~'sTpq(S!Q![(S!c!}(S#R#S(S#T#o(S~(VUpq(Srs(i!Q![(S!c!}(S#R#S(S#T#o(S~(lP!O!P(o~(rPrs(u~(xTpq)X!Q![)X!c!})X#R#S)X#T#o)X~)[Upq)Xrs)n!Q![)X!c!})X#R#S)X#T#o)X~)qP#q#r)t~)wP#q#r)z~*POZ~",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const nobieLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Number: tags.number,
                String: tags.string,
                Identifier: tags.variableName,
                Boolean: tags.bool,
                LineComment: tags.lineComment,
                "( )": tags.paren,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nobie() {
    return new LanguageSupport(nobieLanguage);
}

export { nobie, nobieLanguage };
